<template>
<div>
  <v-app>
    <v-toolbar fixed dark color="blue-grey darken-4">
        <v-toolbar-title>
        </v-toolbar-title>
      <v-spacer></v-spacer>
    </v-toolbar>
    <v-content>
      <v-container fill-height>
        <v-layout align-center justify-center>
          <v-flex xs12 sm8 md4>
            <v-card class="elevation-12">
              <v-tabs
                dark>
                <v-toolbar dark color="blue-grey darken-4">
                  <v-tab>
                    Login
                  </v-tab>
                  <v-tab>
                    Register
                  </v-tab>
                  </v-toolbar>
        <v-tab-item>
          <v-card flat>
            <v-card-text>
              <v-form>
                  <v-text-field v-model="loggedUser.login" prepend-icon="person" name="login" label="Login" type="text"></v-text-field>
                  <v-text-field v-model="loggedUser.password" prepend-icon="lock" name="password" label="Password" id="password" type="password"></v-text-field>
              </v-form>
              <p style="color: red;">{{loginErrorMsg}}</p>
              <v-btn
                @click="loginUser"
              >LOGIN</v-btn>
              <div>
                <a href="#" style="color: black;">Restore password</a>
              </div>
            </v-card-text>
          </v-card>
        </v-tab-item>
      <v-tab-item>
          <v-card flat>
            <v-card-text>
              <v-form>
                  <v-text-field v-model="newName" prepend-icon="person" name="name" label="Name" type="text" ></v-text-field>
                  <v-text-field v-model="newLogin" prepend-icon="person" name="login" label="Login" type="text"></v-text-field>
                  <v-text-field v-model="newPassword" prepend-icon="lock" name="password" label="Password" id="password" type="password"></v-text-field>
              </v-form>
              <p style="color: red;">{{registerErrorMsg}}</p>
              <v-btn
                @click="createNewUser"
              >Register</v-btn>

            </v-card-text>
          </v-card>
        </v-tab-item>
      </v-tabs>
            </v-card>
          </v-flex>
        </v-layout>
      </v-container>
    </v-content>
    <v-footer
      fixed
      height="auto"
    >
      <v-layout
        justify-center
        row
        wrap
      >
        <v-flex
          blue-grey darken-4
          py-3
          text-xs-center
          white--text
          xs12
        >
          &copy;2019 — <strong>Maksim Gerasimchuk</strong>
        </v-flex>
      </v-layout>
    </v-footer>
  </v-app>
</div>
</template>

<script>
export default {
  name: 'Login',
  data () {
    return {
      registeredUsers: [],
      loggedUser: {
        name: null,
        login: null,
        password: null
      },
      newName: '',
      newLogin: '',
      newPassword: '',
      registerErrorMsg: '',
      loginErrorMsg: ''
    }
  },
  mounted () {
    if (localStorage.getItem('registeredUsers')) {
      try {
        this.registeredUsers = JSON.parse(localStorage.getItem('registeredUsers'))
      } catch (e) {
        localStorage.removeItem('registeredUsers')
      }
    }
    if (localStorage.getItem('loggedUser')) {
      try {
        this.loggedUser = JSON.parse(localStorage.getItem('loggedUser'))
      } catch (e) {
        localStorage.removeItem('loggedUser')
      }
    }
  },
  methods: {
    createNewUser () {
      let found = false
      for (let i = 0; i < this.registeredUsers.length; i++) {
        if (this.registeredUsers[i].name === this.newName &&
        this.registeredUsers[i].login === this.newLogin) {
          found = true
          break
        }
      }
      if (!found) {
        this.registerErrorMsg = ''
        this.registeredUsers.push(
          {
            name: this.newName,
            login: this.newLogin,
            password: this.newPassword
          }
        )
        const parsed = JSON.stringify(this.registeredUsers)
        localStorage.setItem('registeredUsers', parsed)
        this.loggedUser.name = this.newName
        this.loggedUser.login = this.newLogin
        this.loggedUser.password = this.newPassword
        this.loginUser()
      } else {
        this.registerErrorMsg = 'Attempt failed: user already exists'
      }
    },
    loginUser () {
      let found
      for (let i = 0; i < this.registeredUsers.length; i++) {
        if (this.registeredUsers[i].login === this.loggedUser.login &&
          this.registeredUsers[i].password === this.loggedUser.password) {
          found = this.registeredUsers[i]
          break
        }
      }
      if (found) {
        const parsed = JSON.stringify(found)
        localStorage.setItem('loggedUser', parsed)
        this.loginErrorMsg = ''
        this.$router.push('/main')
      } else {
        this.loggedUser.login = null
        this.loggedUser.password = null
        this.loginErrorMsg = 'Login failed!'
      }
    }
  }
}
</script>

<style scoped>

</style>
